<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="上级部门" prop="parentId">
        <el-tree-select
            v-model="formData.parentId"
            :data="deptTree"
            :props="defaultProps"
            check-strictly
            default-expand-all
            placeholder="请选择上级部门"
            value-key="deptId"
        />
      </el-form-item>
      <el-form-item label="部门名称" prop="name">
        <el-input v-model="formData.name" placeholder="请输入部门名称" />
      </el-form-item>
      <el-form-item label="部门编码" prop="code">
        <el-input v-model="formData.code" placeholder="请输入部门编码" />
      </el-form-item>
      <el-form-item label="显示排序" prop="sort">
        <el-input-number v-model="formData.sort" :min="0" controls-position="right" />
      </el-form-item>
      <el-form-item label="部门类型" prop="status">
        <el-radio-group v-model="formData.deptType">
          <el-radio
              v-for="dict in getIntDictOptions(DICT_TYPE.HR_DEPT_TYPE)"
              :key="dict.value"
              :value="dict.value"
          >
            {{ dict.label }}
          </el-radio>
        </el-radio-group>
      </el-form-item>
      <el-form-item label="部门负责人" prop="mainEmployeeId">
        <el-select v-model="formData.mainEmployeeId" clearable placeholder="请输入部门负责人">
          <el-option
              v-for="item in userList"
              :key="item.id"
              :label="item.nickname"
              :value="item.id"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="分管领导" prop="leaderEmployeeId">
        <el-select v-model="formData.leaderEmployeeId" clearable placeholder="请输入分管领导">
          <el-option
              v-for="item in userList"
              :key="item.id"
              :label="item.nickname"
              :value="item.id"
          />
        </el-select>
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { DeptApi, Dept } from '@/api/hr/dept'
import { defaultProps, handleTree } from '@/utils/tree'
import * as UserApi from "@/api/system/user";
import {DICT_TYPE, getIntDictOptions} from "@/utils/dict";

/** 部门 表单 */
defineOptions({ name: 'DeptForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  sort: undefined,
  parentId: undefined,
  deptType: undefined,
  name: undefined,
  code: undefined,
  mainEmployeeId: undefined,
  leaderEmployeeId: undefined,
})
const formRules = reactive({
  sort: [{ required: true, message: '显示顺序不能为空', trigger: 'blur' }],
  parentId: [{ required: true, message: '父级ID 顶级部门为0不能为空', trigger: 'blur' }],
  deptType: [{ required: true, message: '1 公司 2 部门不能为空', trigger: 'change' }],
  name: [{ required: true, message: '部门名称不能为空', trigger: 'blur' }],
  code: [{ required: true, message: '部门编码不能为空', trigger: 'blur' }],
})
const formRef = ref() // 表单 Ref
const deptTree = ref() // 树形结构
const userList = ref<UserApi.UserVO[]>([]) // 用户列表

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await DeptApi.getDept(id)
    } finally {
      formLoading.value = false
    }
  }
  await getDeptTree()
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as Dept
    if (formType.value === 'create') {
      await DeptApi.createDept(data)
      message.success(t('common.createSuccess'))
    } else {
      await DeptApi.updateDept(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    sort: undefined,
    parentId: undefined,
    deptType: undefined,
    name: undefined,
    code: undefined,
    mainEmployeeId: undefined,
    leaderEmployeeId: undefined,
  }
  formRef.value?.resetFields()
}

/** 获得部门树 */
const getDeptTree = async () => {
  deptTree.value = []
  const data = await DeptApi.getDeptList()
  const root: Tree = { id: 0, name: '顶级部门', children: [] }
  root.children = handleTree(data, 'id', 'parentId')
  deptTree.value.push(root)
}
</script>
